package com.hungraim.ltc.controller;

import com.hungraim.ltc.util.CsoftSecurityUtil;
import com.hungraim.ltc.util.Result;
import com.nimbusds.jose.jwk.JWKSet;
import com.nimbusds.jose.jwk.RSAKey;
import lombok.AllArgsConstructor;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.security.KeyPair;
import java.security.interfaces.RSAPublicKey;
import java.util.Map;

/**
 * @author hubin
 */
@RestController
@RequestMapping
@AllArgsConstructor
@Slf4j
public class PublicKeyController {

  private final KeyPair keyPair;

  @GetMapping("/getPublicKey")
  public Map<String, Object> loadPublicKey() {
    RSAPublicKey publicKey = (RSAPublicKey) keyPair.getPublic();
    RSAKey key = new RSAKey.Builder(publicKey).build();
    return new JWKSet(key).toJSONObject();
  }

  /**
   * 获取公钥
   * @return
   */
  @GetMapping("/genKeyPair")
  public Result<String> genKeyPair() {
    Map keyMap = CsoftSecurityUtil.genKeyPair();
    return Result.success(keyMap.get(0).toString());
  }

}
